Index: branches/SHM-6-dev/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/SHM-6-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 796)
+++ branches/SHM-6-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 797)
@@ -575,13 +575,8 @@
 #endif
   ("ConformanceMode%d",       cfg_conformanceMode,0, MAX_LAYERS, "Window conformance mode (0: no cropping, 1:automatic padding, 2: padding, 3:cropping")
-#if SCALABILITY_MASK_E0104
   ("ScalabilityMask1",        m_scalabilityMask[1], 0, "scalability_mask[1] (multiview)")
   ("ScalabilityMask2",        m_scalabilityMask[2], 1, "scalability_mask[2] (scalable)" )
 #if AUXILIARY_PICTURES
   ("ScalabilityMask3",        m_scalabilityMask[3], 0, "scalability_mask[3] (auxiliary pictures)" )
-#endif
-#else
-  ("ScalabilityMask0",        m_scalabilityMask[0], 0, "scalability_mask[0] (multiview)")
-  ("ScalabilityMask1",        m_scalabilityMask[1], 1, "scalability_mask[1] (scalable)" )
 #endif
   ("BitstreamFile,b",         cfg_BitstreamFile, string(""), "Bitstream output file name")
@@ -2514,16 +2509,11 @@
 #if SVC_EXTENSION  
   printf("Total number of layers        : %d\n", m_numLayers       );
-#if SCALABILITY_MASK_E0104
-  printf("Multiview                     : %d\n", m_scalabilityMask[1] );
-  printf("Scalable                      : %d\n", m_scalabilityMask[2] );
+  printf("Multiview                     : %d\n", m_scalabilityMask[VIEW_ORDER_INDEX] );
+  printf("Scalable                      : %d\n", m_scalabilityMask[SCALABILITY_ID] );
 #if AVC_BASE
   printf("Base layer                    : %s\n", m_avcBaseLayerFlag ? "AVC" : "HEVC");
 #endif
 #if AUXILIARY_PICTURES
-  printf("Auxiliary pictures            : %d\n", m_scalabilityMask[3] );
-#endif
-#else
-  printf("Multiview                     : %d\n", m_scalabilityMask[0] );
-  printf("Scalable                      : %d\n", m_scalabilityMask[1] );
+  printf("Auxiliary pictures            : %d\n", m_scalabilityMask[AUX_ID] );
 #endif
 #if M0040_ADAPTIVE_RESOLUTION_CHANGE
Index: branches/SHM-6-dev/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/SHM-6-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 796)
+++ branches/SHM-6-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 797)
@@ -512,9 +512,5 @@
     }
 #if MAX_ONE_RESAMPLING_DIRECT_LAYERS
-#if SCALABILITY_MASK_E0104
-    if( m_pcVPS->getScalabilityMask(2) )
-#else
-    if( m_pcVPS->getScalabilityMask(1) )
-#endif
+    if( m_pcVPS->getScalabilityMask( SCALABILITY_ID ) )
     {
       Int numResampler = 0;
Index: branches/SHM-6-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/SHM-6-dev/source/Lib/TLibCommon/TypeDef.h	(revision 796)
+++ branches/SHM-6-dev/source/Lib/TLibCommon/TypeDef.h	(revision 797)
@@ -113,5 +113,4 @@
 #define SCALINGLIST_INFERRING            1      ///< JCTVC-N0371: inter-layer scaling list
 #define O0142_CONDITIONAL_SPS_EXTENSION  1      ///< JCTVC-O0142: Conditional SPS extension
-#define SCALABILITY_MASK_E0104           1      ///< JCT3V-E0104: scalability mask for depth
 #if POC_RESET_FLAG
 #define PREVTID0_POC_RESET               1      ///< JCTVC-O0117 Modification of the PicOrderCntVal of prevTid0Pic
@@ -221,12 +220,12 @@
 #define Q0189_TMVP_CONSTRAINTS           1
 #define Q0247_FRAME_FIELD_INFO           1
-#if VIEW_ID_RELATED_SIGNALING
+
 /// scalability types
 enum ScalabilityType
 {
   VIEW_ORDER_INDEX  = 1,
-  SCALABILITY_ID = 2,
-};
-#endif
+  SCALABILITY_ID    = 2,
+  AUX_ID            = 3,
+};
 
 /// normative encoder constraints --------
Index: branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 796)
+++ branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 797)
@@ -413,9 +413,5 @@
 
           //only for scalable extension
-#if SCALABILITY_MASK_E0104
-          assert( pcSlice->getVPS()->getScalabilityMask(2) == true );
-#else
-          assert( pcSlice->getVPS()->getScalabilityMask(1) == true );
-#endif
+          assert( pcSlice->getVPS()->getScalabilityMask( SCALABILITY_ID ) == true );
         }
       }
Index: branches/SHM-6-dev/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- branches/SHM-6-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 796)
+++ branches/SHM-6-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 797)
@@ -810,9 +810,5 @@
 
             //only for scalable extension
-#if SCALABILITY_MASK_E0104
-            assert( m_cVPS.getScalabilityMask(2) == true );
-#else
-            assert( m_cVPS.getScalabilityMask(1) == true );
-#endif
+            assert( m_cVPS.getScalabilityMask( SCALABILITY_ID ) == true );
           }
         }
@@ -874,9 +870,5 @@
 
             //only for scalable extension
-#if SCALABILITY_MASK_E0104
-            assert( m_cVPS.getScalabilityMask(2) == true );
-#else
-            assert( m_cVPS.getScalabilityMask(1) == true );
-#endif
+            assert( m_cVPS.getScalabilityMask( SCALABILITY_ID ) == true );
           }
         }